﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SharpDX;
using SharpDX.Toolkit.Graphics;

namespace PackingPlanVisualizations {               

  [Serializable]
  public struct VertexPositionColorNormal : IEquatable<VertexPositionColorNormal> {
    [VertexElement("COLOR")]
    public Color Color;
    [VertexElement("SV_Position")]
    public Vector3 Position;
    [VertexElement("NORMAL")]
    public Vector3 Normal;


    public VertexPositionColorNormal(Color color, Vector3 position, Vector3 normal) {
      Position = position;
      Color = color;
      Normal = normal;
    }

    public static bool operator !=(VertexPositionColorNormal left, VertexPositionColorNormal right) {
      return !left.Equals(right);
    }
    public static bool operator ==(VertexPositionColorNormal left, VertexPositionColorNormal right) {
      return left.Equals(right);
    }

    public override bool Equals(object obj) {
      if (obj.GetType() == typeof (VertexPositionColorNormal))
        return this.Equals((VertexPositionColorNormal)obj);
      else
        return false;
    }

    public bool Equals(VertexPositionColorNormal other) {
      return this.Normal == other.Normal && this.Position == other.Position && this.Color == other.Color;
    }

    public override int GetHashCode() {
      return this.Color.GetHashCode() * 3 + this.Normal.GetHashCode() * 7 + this.Position.GetHashCode() * 11;
    }

    public override string ToString() {
      return String.Format("VertexPositionColorNormal (Position: {0}; Color: {1}; Normal: {2})", this.Position, this.Color, this.Normal);
    }

  }
}
